#include <FL/gl.h>
#include "Painter3D.h"
#include "UserInterface.h"

void Painter3D::PlayMovie()
{
    if ( m_adataMovie.size() == 0 )
        return;

    m_iFrame = 0;
    m_bPlayMovie = true;
    m_adataMovie[0].PushToUI( m_opUI );

    Redraw();
}

void Painter3D::ClearMovie()
{
    m_adataMovie.resize(0);
}
///
///
void Painter3D::WriteMovie( const char *in_str )
{
    ofstream out;
    WINWriteBinary(in_str, out);

    out << m_adataMovie.size() << "\n";
    for ( int i = 0; i < m_adataMovie.size(); i++ )
        m_adataMovie[i].Write(out);
    out.close();
}

void Painter3D::ReadMovie( const char *in_str )
{
    ifstream in;
    WINReadBinary( in_str, in);

    int iN = 0;
    in >> iN;
    m_adataMovie.resize(iN);
    for ( int i = 0; i < m_adataMovie.size(); i++ )
        m_adataMovie[i].Read(in);
    
    /*
    DisplayData data = m_adataMovie.last();
    for ( FORINT i = 0; i < 60; i++ )
        m_adataMovie += data;
     */
    in.close();
}

void Painter3D::WriteMovieImage()
{
    static IMAGERaw s_image;
    static char s_strN[10];
    
    string str( "../Data/3DPaintings/Video/" ), strTag;
    const size_t iSlash = m_strImageName.rfind("/");
    string strFName = m_strImageName;
    if ( iSlash != string::npos )
        strFName = m_strImageName.substr( iSlash+1 );
    
    if ( m_bPlayMovie == true ) {
        
        if ( m_opUI->m_bWriteImages->value() ) {
            OGLImages_GetImage( s_image );

            str += strFName;
            sprintf( s_strN, "%0.4d", m_iFrame );
            if ( m_opUI->m_bShowHeight->value() ) {
                strTag = string("_Height");
            } else if ( m_opUI->m_bShowHeightColor->value() ) {
                strTag = string("_Simple");
            } else if ( m_opUI->m_bShowColor->value() ) {
                strTag = string("_Color");
            } else if ( m_opUI->m_bShowLayer->value() ) {
                strTag = string("_Layer");
            }
            if ( m_opUI->m_bEnvironmentMap->value() ) {
                strTag = strTag + string("_Env");
            }
            str += strTag + string( s_strN );
            str += m_strFileExtension;

            s_image.Write( str.c_str() );
            cerr << "Wrote " << m_iFrame << "\n";            
        }
        m_iFrame++;

        if ( m_iFrame < m_adataMovie.size() ) {
            m_adataMovie[m_iFrame].PushToUI( m_opUI );
        } else {
            m_bPlayMovie = false;
            m_iFrame = -1;
        }
         
    }
}
