/*
 *  UTILSColor.cpp
 *  Painter3D
 *
 *  Created by Cindy Grimm on 2/27/09.
 *  Copyright 2009 __MyCompanyName__. All rights reserved.
 *
 */

#include "UTILSColor.h"

const double UTILSColor::sm_aadColors[ 8 ][ 3 ] = 
{ { 1, 0, 0 }, { 0, 1, 0 }, { 0, 0, 1 },
    { 1, 0, 1 }, { 1, 1, 0 }, { 1, 1, 1 }, 
    { 0.5, 0.5, 0.5 }, { 0, 0, 0 } };

//------------------------------------------------------------------------------------------

bool UTILSColor::operator==( const UTILSColor & in_rcoDotColor ) const
{ 
    for ( int iI = 0; iI < 3; iI++ )
        if ( in_rcoDotColor[ iI ] != m_adC[ iI ] ) return false;
    
    return true;
    
}//UTILSColor::operator==

//------------------------------------------------------------------------------------------

bool UTILSColor::operator==( UTILSColor::Color _c ) const
{ 
    for ( int iI = 0; iI < 3; iI++ )
        if ( m_adC[ iI ] != sm_aadColors[ _c ][ iI ] ) return false;
    
    return true;
    
}//UTILSColor::operator==


//------------------------------------------------------------------------------------------

UTILSColor::UTILSColor( )
{ 
    for ( int iI = 0; iI < 3; iI++ )
        m_adC[ iI ] = sm_aadColors[ UTILSColor::GREY ][ iI ];
    
}//UTILSColor::UTILSColor

//------------------------------------------------------------------------------------------

UTILSColor::UTILSColor( double in_dR, double in_dG, double in_dB )
{ 
    m_adC[ 0 ] = in_dR;
    m_adC[ 1 ] = in_dG;
    m_adC[ 2 ] = in_dB;
    
}//UTILSColor::UTILSColor

//------------------------------------------------------------------------------------------

UTILSColor::UTILSColor( const UTILSColor & in_rcoDotColor )
{ 
    for ( int iI = 0; iI < 3; iI++ )
        m_adC[ iI ] = in_rcoDotColor[ iI ];
    
}//UTILSColor::UTILSColor

//------------------------------------------------------------------------------------------

UTILSColor & UTILSColor::operator=( const UTILSColor & in_rcoDotColor )
{ 
    for ( int iI = 0; iI < 3; iI++ )
        m_adC[ iI ] = in_rcoDotColor[ iI ];
    
    return *this;
    
}//UTILSColor::operator=

//------------------------------------------------------------------------------------------

void UTILSColor::Write( ofstream & io_rstrmOut ) const
{ 
    io_rstrmOut << m_adC[ 0 ] << " " << m_adC[ 1 ] << " " << m_adC[ 2 ] << "  ";
    
}//UTILSColor::Write

//------------------------------------------------------------------------------------------

bool UTILSColor::Read( ifstream & in_rstrmIn )
{ 
    in_rstrmIn >> m_adC[ 0 ] >> m_adC[ 1 ] >> m_adC[ 2 ];
    
    if ( in_rstrmIn.good() ) return true;
    return false;
    
}//UTILSColor::Read

